package com.nisum;

import java.util.ArrayList;
import java.util.List;

public class ZigZagConversionAlgo {

    static String[] listOfSubstrings;
    static String resultString;

    public static void main(String[] args) {
        System.out.println(convertString("PAYPALISHIRING", 3));
    }

    public static String convertString(String str, int rows){
        resultString = "";
        listOfSubstrings = populateArrayList(rows);
        distributeLetters(str,rows);
        populateResultString();
        return resultString;
    }

    private static void populateResultString() {
        for (String subString : listOfSubstrings){
            resultString = resultString.concat(subString);
        }
    }

    private static void distributeLetters(String str, int rows) {
        int i = 0;
        boolean incrementing = true;

        for (String letter : str.split("")){
            listOfSubstrings[i] = listOfSubstrings[i].concat(letter);

            if (i == rows - 1){
                incrementing = false;
            } else if (i == 0) {
                incrementing = true;
            }

            if (incrementing) {
                i++;
            } else {
                i--;
            }
        }
    }

    private static String[] populateArrayList(int rows){
        String[] arr = new String[rows];
        for(int i =0; i < rows; i++){
            arr[i] = "";
        }
        return arr;
    }
}

/*
    The string "PAYPALISHIRING" is written in a zigzag pattern on a given number of rows like this: (you may want to display this pattern in a fixed font for better legibility)

        P   A   H   N
        A P L S I I G
        Y   I   R
        And then read line by line: "PAHNAPLSIIGYIR"

        Write the code that will take a string and make this conversion given a number of rows:

        string convert(string s, int numRows);

 */